/**********
 *	NotThisComp
 **********
 *	Filename:		NotThisComp v1.1.jsx
 *	Written by:		Redsandro - http://www.rednet.nl/en/
 *	Date:			2008/12/10
 *	Last updated:	2009/02/14
 **********
 *
 *	Description:
 *
 *	Traverses selected properties in one or more layers for expressions that reference thisComp
 *	and changes them to comp("compName") so the layer can be precomposed and stuff without
 *	breaking layer references.
 *
 **********/



clearOutput();

var myComp = app.project.activeItem;
if (myComp == null) {
	alert("No composition selected.");
}
else {
	// Gather data
	//var compName = "no name";
	//compName = prompt("What name do you want to reference instead of thisComp()", compName));
	var myLayers = myComp.selectedLayers;
	var myCompName = myComp.name;
	var newName = "comp('"+myCompName+"')";

	// Check selected
	if (myLayers.length < 1)
		alert("No layers selected.");
	else {
		var changes = false;
		app.beginUndoGroup("NotThisComp");
		// Walk layers
		for (var l=0; l<myLayers.length; l++) {
			var myLayer = myLayers[l];
			// Walk properties
			//
			if (myLayer.selectedProperties && myLayer.selectedProperties.length > 0) {
 				var selProps = myLayer.selectedProperties;
				if (changes === false) changes = 0; // for knowing props were selected
 				for(var p=0; p<selProps.length; p++) {
					var prop = selProps[p];
					if (prop.canSetExpression == true) {
						if (prop.expression.indexOf("thisComp") != -1) {
							prop.expression = prop.expression.split("thisComp").join(newName);
							changes++;
						}
					}
				}
			}
		}
		app.endUndoGroup();

		if (changes === false) alert("No properties were selected.");
		else if (changes == 0) alert("No instance of 'thisComp' found.");
		else alert("Replaced: " + changes);
	}
}
